
//-------------------------------------------------<                   axlib v1.1                    >----------------------------------------------------
//-------------------------------------------------<        PCF8574  >----------------------------------------------------
//-------------------------------------------------<      2015 http://www.avrki.ru    >----------------------------------------------------

#ifndef PCF8574_H_
#define PCF8574_H_

#if !defined(MAIN_INIT_H_)
#error "You must included (#include \"main_init.h\") befor use (#include <axlib/pcf8574.h>)."
#endif
#if !defined(I2C_H_)
#error "You must included (#include <axlib/i2c.h>) befor use (#include <axlib/pcf8574.h>)."
#endif

//-------------------------------------------------------------------------
//						  
//-------------------------------------------------------------------------

//-------------------------------------------------------------------------
//							 
//-------------------------------------------------------------------------

#include <axlib/type_var.h>

//-------------------------------------------------------------------------
//							 
//-------------------------------------------------------------------------

//-------------------------------------------------------------------------
//	     .
//
//	 :
//
//		BYTE add  -  .
//
//	 ACK     ,  NACK
//
//-------------------------------------------------------------------------

BYTE pcf8574_test(BYTE add)
{
	BYTE ask = ACK;
	add &= 0xFE;

	i2c_start();	
	ask = i2c_send_byte(add);
	i2c_stop();
	
	return ask;
}

//-------------------------------------------------------------------------
//	     .
//
//	 :
//
//		BYTE data -     .
//		BYTE add -  
//
//	 ACK    NACK  
//-------------------------------------------------------------------------

BYTE pcf8574_byte_out(BYTE data, BYTE add)
{
	BYTE ask = ACK;
	add &= 0xFE;
	
	i2c_start();
	ask = i2c_send_byte(add);
	if(!ask) ask = i2c_send_byte(data);
	i2c_stop();
	
	return ask;
}

//-------------------------------------------------------------------------
//	      .
//
//	 :
//
//		BYTE *data -        .
//		BYTE col -    
//		BYTE add -  
//
//	 ACK    NACK  
//-------------------------------------------------------------------------

BYTE pcf8574_str_out(BYTE *data, BYTE col, BYTE add)
{
	BYTE ask = ACK;
	add &= 0xFE;
	
	i2c_start();
	ask = i2c_send_byte(add);
	for(BYTE i=0; i<col; i++)
	{
		ask = i2c_send_byte(*data);
		if(ask) 
		{
			i2c_stop();
			return ask;
		}
		data++;
	}
	i2c_stop();
	
	return ask;
}

#endif /* PCF8574_H_ */