
//-------------------------------------------------<                axlib v1.1                 >----------------------------------------------------
//-------------------------------------------------<        >----------------------------------------------------
//-------------------------------------------------<   2015 http://www.avrki.ru >----------------------------------------------------


#ifndef MAIN_INIT_H_
#define MAIN_INIT_H_

//   

#define F_CPU 16000000UL

//   

#include <util/delay.h>

#define FULL	0xFF
//-------------------------------------------------------------------------
//          
//  40   4   4-  .
//
//	   
//	    
//     
//
//	 R/W      GND
//
//       74HC595,  
//      .
//
//-------------------------------------------------------------------------
#define DDR_RS	DDRD	//     RS
#define DDR_E	DDRD	//     
#define DDR_D4	DDRD	//     D4
#define DDR_D5	DDRD	//     D5
#define DDR_D6	DDRD	//     D6
#define DDR_D7	DDRD	//     D7

#define PORT_RS	PORTD	//     RS
#define PORT_E	PORTD	//     
#define PORT_D4	PORTD	//     D4
#define PORT_D5	PORTD	//     D5
#define PORT_D6	PORTD	//     D6
#define PORT_D7	PORTD	//     D7

#define RS		2		//   RS
#define E		3		//   
#define D4		4		//   D4
#define D5		5		//   D5
#define D6		6		//   D6
#define D7		7		//   D7

//-------------------------------------------------------------------------
//	       QAPASS 1602A
//	    TRUE   
//  #define.    
//	(       .
//      .)
//
//-------------------------------------------------------------------------

#define RUS		FALSE

//-------------------------------------------------------------------------
//         74HC595
//
//        40   4  
//	 4-     ,   
//	     :
//
//	74HC595 |   LCD 
//	------------------
//	|   Q2	|	RS   |
//  ------------------
//	|   Q3	|	E    |
//  ------------------
//	|   Q4	|	D4   |
//  ------------------
//	|   Q5	|	D5   |
//  ------------------
//	|   Q6	|	D6   |
//  ------------------
//	|   Q7	|	D7   |
//  ------------------
//
//	 R/W      GND
// 
//       ,  
//     #define R74HC595_LCD
//
//-------------------------------------------------------------------------

//#define R74HC595_LCD //      

//-------------------------------------------------------------------------

#define R74HC595_PORT_RESET	PORTD	//     RESET
#define R74HC595_PORT_CLK	PORTD	//     CLK
#define R74HC595_PORT_SHIFT	PORTD	//     SHIFT
#define R74HC595_PORT_DATA	PORTD	//     DATA

#define R74HC595_DDR_RESET	DDRD	//     RESET
#define R74HC595_DDR_CLK	DDRD	//     CLK
#define R74HC595_DDR_SHIFT	DDRD	//     SHIFT
#define R74HC595_DDR_DATA	DDRD	//     DATA

#define R74HC595_RESET		2		//   
#define R74HC595_CLK		3		//  
#define R74HC595_SHIFT		4		//  
#define R74HC595_DATA		5		//  


//-------------------------------------------------------------------------
//       SPI   Slave
//
// S_OUT         
//-------------------------------------------------------------------------

#define DDR_S_OUT	DDRB	//     S_OUT
#define PORT_S_OUT	PORTB	//     S_OUT
#define S_OUT		0		//    S_OUT

//-------------------------------------------------------------------------
//       TFT  ST7735 160128
//
//         
// CS    
// A0    /
// RES     
//-------------------------------------------------------------------------

#define DDR_CS		DDRD	//     CS
#define DDR_A0		DDRD	//     A0
#define DDR_RES		DDRD	//     RES

#define PORT_CS		PORTD	//     CS
#define PORT_A0		PORTD	//     A0
#define PORT_RES	PORTD	//     RES

#define CS			0		//    CS
#define A0			1		//    A0
#define RES			2		//    RES

//-------------------------------------------------------------------------
//         -2106 ( )
//       0 /  290   320 
//
//	      :
//
//                      U    . (  5)
//                    -----
//                      |
//                      |
//                     ---
//                    |   |
//                    |   |  .    (  300 ,  8 /)
//                     ---
//                      |
//                      |_____________   
//                      |
//                      |
//                     ---
//                    |   |
//                    |   |      (  22 )
//                     ---
//                      |
//                      |
//                    -----
//                     GND
//
//-------------------------------------------------------------------------

//-------------------------------------------------------------------------
//	    1wire        
//
//	:
//
//	       .
//	     ,    .
//-------------------------------------------------------------------------

#define PORT_W		B		//   1-wire    A, B, C, D.
#define PIN_W		0		//       1-wire.

//-------------------------------------------------------------------------
//	    I2C        
//
//-------------------------------------------------------------------------

#define I2C_DDR		DDRC	//    
#define I2C_PORT	PORTC	//    
#define I2C_PIN		PINC	//    

#define SCL			5		//   SCL
#define SDA			4		//   SDA

//-------------------------------------------------------------------------
//	  c OLED  SSD1306   .
//      .
//
//              
//  .      .
//-------------------------------------------------------------------------

#define SSD1306_ADD		0x78
//#define SSD1306_ADD		0x70

//-------------------------------------------------------------------------
//	  c 7-    4 
//	       
//	  74HC595
//	      ,   . 
//	  ,        .
//	    . 
//
//-------------------------------------------------------------------------
#define PORT_LED_DIG	PORTD	//     
#define PORT_LED_DATA	PORTB	//     

#define DDR_LED_DIG		DDRD	//     
#define DDR_LED_DATA	DDRB	//     

#define LED_DATA		0		//  
#define LED_SCK			2		// 
#define LED_SHIFT		1		// 
#define LED_RESET		3		// 
#define LED_DIG_1		7		//  
#define LED_DIG_2		6		//  
#define LED_DIG_3		5		//  
#define LED_DIG_4		4		//  

//-------------------------------------------------------------------------
//   MH-BUS     
//	    RS-485        
//	      .
//
//     ID      1  65535
//-------------------------------------------------------------------------

//   ,   
//     RS-485

//#define MH_BUS_RS485_ON				//   RS-485

//        

#define MH_BUS_MASTER					//    

//        

//#define MH_BUS_SLAVE					//    

//       
#if defined(MH_BUS_SLAVE)
	#define MH_BUS_SLAVE_ID	65530U		//   
#endif
	
#define MH_BUS_USART_BOD	115200		//   
	
//        
//     RS-485
#if defined(MH_BUS_RS485_ON)
	#define RS_485_DDR			DDRC	//       
	#define RS_485_PORT			PORTC	//       
	#define RS_485_PIN			2   	//    
#endif

#endif /* MAIN_INIT_H_ */